package main

import (
	"fmt"
	"math/rand"

	neuralnetwork "./neuralnetworkbase"
	mat "gonum.org/v1/gonum/mat"
)

func main() {
	sizes := []int{3, 2, 2}
	nn := neuralnetwork.NewNeuralNetwork(sizes)

	data := make([]float64, sizes[0])
	for i := range data {
		data[i] = rand.Float64()
	}
	aIn := mat.NewDense(sizes[0], 1, data)

	nn.Forward(aIn)

	for i := 0; i < nn.Count; i++ {
		if i > 0 {
			fmt.Printf("Weights:\n%v\n\n", mat.Formatted(nn.Weights[i], mat.Prefix(""), mat.Excerpt(0)))
			fmt.Printf("Biases:\n%v\n\n", mat.Formatted(nn.Biases[i], mat.Prefix(""), mat.Excerpt(0)))
			fmt.Printf("Z:\n%v\n\n", mat.Formatted(nn.Z[i], mat.Prefix(""), mat.Excerpt(0)))
		}
		fmt.Printf("A:\n%v\n\n", mat.Formatted(nn.A[i], mat.Prefix(""), mat.Excerpt(0)))
	}
}
